<?php

use CRM_FormProcessor_ExtensionUtil as E;

/**
 * @author Jaap Jansma (CiviCooP) <jaap.jansma@civicoop.org>
 * @license http://www.gnu.org/licenses/agpl-3.0.html
 */
class CRM_FormProcessor_DAO_FormProcessorInstance extends CRM_Core_DAO {
  /**
   * static instance to hold the field values
   *
   * @var array
   * @static
   */
  static $_fields = null;
  static $_export = null;
  /**
   * empty definition for virtual function
   */
  static function getTableName() {
    return 'civicrm_form_processor_instance';
  }
  /**
   * returns all the column names of this table
   *
   * @access public
   * @return array
   */
  public static function &fields() {
    if (!(self::$_fields)) {
      self::$_fields = array(
        'id' => array(
          'name' => 'id',
          'title' => E::ts('ID'),
          'type' => CRM_Utils_Type::T_INT,
          'required' => true
        ) ,
        'name' => array(
          'name' => 'name',
          'title' => E::ts('Name'),
          'type' => CRM_Utils_Type::T_STRING,
          'maxlength' => 80,
        ) ,
        'title' => array(
          'name' => 'title',
          'title' => E::ts('Title'),
          'type' => CRM_Utils_Type::T_STRING,
          'maxlength' => 128,
          'required' => true
        ),
        'is_active' => array(
          'name' => 'is_active',
          'title' => E::ts('Is active'),
          'type' => CRM_Utils_Type::T_INT,
        ),
        'description' => array(
          'name' => 'description',
          'title' => E::ts('Description'),
          'type' => CRM_Utils_Type::T_STRING,
        ),
        'output_handler' => array(
          'name' => 'output_handler',
          'title' => E::ts('Output handler'),
          'type' => CRM_Utils_Type::T_STRING,
          'maxlength' => 88,
          'required' => true,
        ) ,
        'output_handler_configuration' => array(
        	'name' => 'output_handler_configuration',
          'title' => E::ts('Output handler Configuration'),
          'type' => CRM_Utils_Type::T_TEXT,
				),
				'enable_default_data' => array(
          'name' => 'enable_default_data',
          'title' => E::ts('Enable default data'),
          'type' => CRM_Utils_Type::T_INT,
        ),
        'default_data_output_configuration' => array(
        	'name' => 'default_data_output_configuration',
          'title' => E::ts('Default data output configuration'),
          'type' => CRM_Utils_Type::T_TEXT,
				),
        'created_date' => array(
          'name' => 'created_date',
          'type' => CRM_Utils_Type::T_DATE
        ),
        'created_user_id' => array(
          'name' => 'created_user_id',
          'type' => CRM_Utils_Type::T_INT,
          'FKApiName' => 'Contact',
        ),
        'modified_date' => array(
          'name' => 'modified_date',
          'type' => CRM_Utils_Type::T_DATE
        ),
        'modified_user_id' => array(
          'name' => 'modified_user_id',
          'type' => CRM_Utils_Type::T_INT,
          'FKApiName' => 'Contact',
        ),
      );
    }
    return self::$_fields;
  }
  /**
   * Returns an array containing, for each field, the array key used for that
   * field in self::$_fields.
   *
   * @access public
   * @return array
   */
  public static function &fieldKeys() {
    if (!(self::$_fieldKeys)) {
      self::$_fieldKeys = array(
        'id' => 'id', 
        'name' => 'name',
        'label' => 'label',
        'is_active' => 'is_active',
        'description' => 'description',
        'output_handler' => 'outpunt_handler',
        'output_handler_configuration' => 'output_handler_configuration',
        'enable_default_data' => 'enable_default_data',
        'default_data_output_configuration' => 'default_data_output_configuration',
        'created_date' => 'created_date',
        'created_user_id' => 'created_user_id',
        'modified_date' => 'modified_date',
        'modified_user_id' => 'modified_user_id',
      );
    }
    return self::$_fieldKeys;
  }
  /**
   * returns the list of fields that can be exported
   *
   * @access public
   * return array
   * @static
   */
  static function &export($prefix = false)
  {
    if (!(self::$_export)) {
      self::$_export = array();
      $fields = self::fields();
      foreach($fields as $name => $field) {
        if (CRM_Utils_Array::value('export', $field)) {
          if ($prefix) {
            self::$_export['form_processor_instance'] = & $fields[$name];
          } else {
            self::$_export[$name] = & $fields[$name];
          }
        }
      }
    }
    return self::$_export;
  }
}